USE [p_datamart1]
GO

/****** Object:  UserDefinedFunction [dbo].[FN_SPLIT]    Script Date: 05/24/2013 12:13:51 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[FN_SPLIT] (@DELIMITER CHAR(1), @STRING NVARCHAR(512)) 
RETURNS TABLE 
AS 
RETURN ( 
  WITH PIECES(PIECE_NUM, START, STOP) AS ( 
   SELECT 1, 1, CHARINDEX(@DELIMITER, @STRING) 
   UNION ALL 
   SELECT PIECE_NUM + 1, STOP + 1, CHARINDEX(@DELIMITER, @STRING, STOP + 1) 
   FROM PIECES 
   WHERE STOP > 0 
  ) 
  SELECT PIECE_NUM, 
   SUBSTRING(@STRING, START, CASE WHEN STOP > 0 THEN STOP - START ELSE 512 END) AS PIECE 
  FROM PIECES 
 ) 

GO


USE [p_datamart1]
GO
/****** Object:  StoredProcedure [dbo].[store_olap_log_measure]    Script Date: 05/24/2013 12:14:22 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[store_olap_log_measure]
	-- Add the parameters for the stored procedure here
	@measurelist nvarchar(4000), @databasename nvarchar(128)
AS
BEGIN

	INSERT INTO dbo.log_olap_trace_measures
	SELECT PIECE, @databasename As Measure FROM FN_Split(',',@measurelist)

END



CREATE TABLE [dbo].[log_olap_trace_measures](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Measure] [varchar](500) NOT NULL,
	[DatabaseName] [varchar](50) NOT NULL,
 CONSTRAINT [PK_log_olap_trace_measures] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]

GO


CREATE TABLE [dbo].[log_olap_trace_tmp](
	[RowNumber] [int] NULL,
	[EventClass] [int] NULL,
	[EventSubclass] [int] NULL,
	[TextData] [ntext] NULL,
	[ConnectionID] [int] NULL,
	[NTUserName] [nvarchar](128) NULL,
	[ApplicationName] [nvarchar](128) NULL,
	[StartTime] [datetime] NULL,
	[CurrentTime] [datetime] NULL,
	[Duration] [bigint] NULL,
	[DatabaseName] [nvarchar](128) NULL,
	[Error] [int] NULL,
	[ClientProcessID] [int] NULL,
	[SPID] [int] NULL,
	[CPUTime] [bigint] NULL,
	[NTDomainName] [nvarchar](128) NULL,
	[RequestParameters] [ntext] NULL,
	[RequestProperties] [ntext] NULL,
	[BinaryData] [image] NULL,
	[TextData_String] [nvarchar](4000) NULL,
	[Measures] [nvarchar](4000) NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
